import java.net.URL;

import java.util.Set;
import java.util.Map;
import java.util.Iterator;

import org.infinispan.client.hotrod.RemoteCache;
import org.infinispan.client.hotrod.RemoteCacheManager;

public class HotRodRemoteClient 
{
  public void start()  
  {
    URL resource = Thread.currentThread().getContextClassLoader().getResource("hotrod-client.properties");
    RemoteCacheManager remoteCacheManager = new RemoteCacheManager(resource, true);

//  RemoteCacheManager remoteCacheManager = new RemoteCacheManager("127.0.0.1:7900");
//  RemoteCacheManager remoteCacheManager = new RemoteCacheManager("10.100.9.9");
    
    RemoteCache<Integer, Ticket> remoteCache = remoteCacheManager.getCache("clusteredCache");
//  RemoteCache<Integer, Ticket> remoteCacheManager = rm.getCache();

    String command = ""; // Line read from standard in
    int ticketid = 1;

    IOUtils.dumpWelcomeMessage();

    while (true)
    {
      command = IOUtils.readLine("Enter command name > ");
      if (command.equals("book")) 
      {

        String name = IOUtils.readLine("Enter name: ");
        String show = IOUtils.readLine("Enter show: ");

        Ticket ticket = new Ticket(name,show);
        remoteCache.put(ticketid, ticket);
        log("Booked ticket: "+ticket);
        ticketid++;
      }
      else if (command.equals("pay")) 
      {
        Integer id = new Integer(IOUtils.readLine("Enter ticketid "));
        Ticket ticket = remoteCache.remove(id);
        log("Checked out ticket: "+ticket);
      }
      else if (command.equals("list")) 
      {
    	Map<Integer, Ticket> mp = remoteCache.getBulk();
    	Set s = mp.entrySet();
    	
    	//Move next key and value of Map by iterator
        Iterator it=s.iterator();

        while(it.hasNext())
        {
            // key=value separator this by Map.Entry to get key and value
            Map.Entry m =(Map.Entry)it.next();
            
            // getValue is used to get value of key in Map
            Ticket ticket=(Ticket)m.getValue();
            System.out.println(ticket);
        }
      }
      else if (command.equals("quit")) 
      {
    	Map<Integer, Ticket> mp = remoteCache.getBulk();
        log("Tickets in RemoteCache : "+mp.size());

        remoteCacheManager.stop();
        log("Bye");
        break;
      }
      else 
      {
        log("Unknown command "+command);
        IOUtils.dumpWelcomeMessage();
      }
    }
  }

  public static void main(String[] args) 
  {
    new HotRodRemoteClient().start();
  }

  public static void log(String s)
  {
    System.out.println(s);
  }
}

